#!/usr/bin/env bash

GUIX_PROFILE=~/.guix-home/profile

if [ ! -z "$GUIX_ENVIRONMENT" ]; then
    # When in a guix environment, extend particular environment variables
    # TODO: there are likely more environment variables that should be extended
    export XDG_CONFIG_DIRS="${XDG_CONFIG_DIRS}:$GUIX_ENVIRONMENT/etc/xdg"
fi

export XKB_BINDIR=${GUIX_PROFILE}/bin

exec ${GUIX_PROFILE}/bin/xinit ${HOME}/.xinitrc $@ -- \
  ${GUIX_PROFILE}/bin/Xorg :$XDG_VTNR vt$XDG_VTNR \
    -keeptty \
    -xkbdir ${GUIX_PROFILE}/share/X11/xkb \
    -configdir ${GUIX_PROFILE}/share/X11/xorg.conf.d \
    -modulepath ${GUIX_PROFILE}/lib/xorg/modules
